'VB Script for MsgApi SDK
'Run with Windows Script Host CScript.exe

Option Explicit

Dim colArgs
Set colArgs = WScript.Arguments

Dim objComds
Set objComds = New Commands

If (colArgs.Count > 0) Then
	Dim objCmd
	Set objCmd = objComds.GetCommand(colArgs)
	If Not (objCmd Is Nothing) Then
		Dim strIn
		Dim strId
		Dim strMsgId
		Dim arrKeys
		arrKeys = objCmd.Fields.Keys

		Dim msgapi
		if objCmd.OptionArg = "-e" Or objCmd.OptionArg = "-d" Or objCmd.OptionArg = "-h -e" Or objCmd.OptionArg = "-h -p" Or objCmd.OptionArg = "-g" Or objCmd.OptionArg = "-p" Then
			Set msgapi = CreateObject("Threema.MsgApi.Com.CryptTool")
		Else
			Set msgapi = CreateObject("Threema.MsgApi.Com.MessageTool")
		End If

		Select Case objCmd.OptionArg
'local commands
			Case "-e"
				strIn = GetStdIn()

				Dim arrEncryptTextMessage
				Set arrEncryptTextMessage = msgapi.EncryptTextMessage(strIn, objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)))

				WScript.Echo "Result: " + arrEncryptTextMessage(0)
				WScript.Echo "Nonce: " + arrEncryptTextMessage(1)
				WScript.Echo "Size: " + arrEncryptTextMessage(2)
			Case "-d"
				strIn = GetStdIn()

				Dim arrDecryptMessage
				Set arrDecryptMessage = msgapi.DecryptMessage(strIn, objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)))
				WScript.Echo "Type: " + arrDecryptMessage(0)
				WScript.Echo "Message: " + arrDecryptMessage(1)
			Case "-h -e"
				Dim strEmailAddressHash
				strEmailAddressHash = msgapi.HashEmail(objCmd.GetFieldsValue(arrKeys(0)))
				WScript.Echo "Hash: " + strEmailAddressHash
			Case "-h -p"
				Dim strPhoneNoHash
				strPhoneNoHash = msgapi.HashPhoneNo(objCmd.GetFieldsValue(arrKeys(0)))
				WScript.Echo "Hash: " + strPhoneNoHash
			Case "-g"
				msgapi.GenerateKeyPair objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1))
			Case "-p"
				Dim strPublicKey
				strPublicKey = msgapi.DerivePublicKey(objCmd.GetFieldsValue(arrKeys(0)))
				WScript.Echo strPublicKey
'network commands
			Case "-s"
				strIn = GetStdIn()

				If colArgs.Count - 1 = 3 Then
					strMsgId = msgapi.SendTextMessageSimple(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), strIn)
				Else
					strMsgId = msgapi.SendTextMessageSimple(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), strIn, objCmd.GetFieldsValue(arrKeys(3)))
				End If

				WScript.Echo strMsgId
			Case "-S"
				strIn = GetStdIn()

				If colArgs.Count - 1 = 4 Then
					strMsgId = msgapi.SendTextMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), strIn)
				Else
					strMsgId = msgapi.SendTextMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), strIn, objCmd.GetFieldsValue(arrKeys(4)))
				End If

				WScript.Echo strMsgId
			Case "-S -i"
				If colArgs.Count - 2 = 5 Then
					strMsgId = msgapi.SendImageMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), objCmd.GetFieldsValue(arrKeys(4)))
				Else
					strMsgId = msgapi.SendImageMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), objCmd.GetFieldsValue(arrKeys(4)), objCmd.GetFieldsValue(arrKeys(5)))
				End If

				WScript.Echo strMsgId
			Case "-S -f"
				If colArgs.Count - 2 = 5 Then
					strMsgId = msgapi.SendFileMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), objCmd.GetFieldsValue(arrKeys(4)))
				ElseIf colArgs.Count - 2 = 6 Then
					strMsgId = msgapi.SendFileMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), objCmd.GetFieldsValue(arrKeys(4)), objCmd.GetFieldsValue(arrKeys(5)))
				Else
					strMsgId = msgapi.SendFileMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), objCmd.GetFieldsValue(arrKeys(4)), objCmd.GetFieldsValue(arrKeys(5)), objCmd.GetFieldsValue(arrKeys(6)))
				End If

				WScript.Echo strMsgId
			Case "-l -e"
				If colArgs.Count - 2 = 3 Then
					strId = msgapi.LookupEmail(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)))
				Else
					strId = msgapi.LookupEmail(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)))
				End If

				WScript.Echo strId
			Case "-l -p"
				If colArgs.Count - 2 = 3 Then
					strId = msgapi.LookupPhone(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)))
				Else
					strId = msgapi.LookupPhone(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)))
				End If

				WScript.Echo strId
			Case "-l -k"
				If colArgs.Count - 2 = 3 Then
					strId = msgapi.LookupKey(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)))
				Else
					strId = msgapi.LookupKey(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)))
				End If

				WScript.Echo strId
			Case "-c"
				Dim arrCapabilities
				If colArgs.Count - 1 = 3 Then
					Set arrCapabilities = msgapi.LookupKeyCapability(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)))
				Else
					Set arrCapabilities = msgapi.LookupKeyCapability(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)))
				End If

				Dim iC
				For iC = 0 To arrCapabilities.Count - 1
					WScript.Echo arrCapabilities(iC)
				Next
			Case "-D"
				strIn = GetStdIn()

				Dim arrReceiveMessage
				if colArgs.Count - 1 = 6 Then
					Set arrReceiveMessage = msgapi.ReceiveMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), objCmd.GetFieldsValue(arrKeys(4)), objCmd.GetFieldsValue(arrKeys(5)), strIn)
				ElseIf colArgs.Count - 1 = 7 Then
					Set arrReceiveMessage = msgapi.ReceiveMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), objCmd.GetFieldsValue(arrKeys(4)), objCmd.GetFieldsValue(arrKeys(5)), strIn, objCmd.GetFieldsValue(arrKeys(6)))
				ElseIf colArgs.Count - 1 = 8 Then
					Set arrReceiveMessage = msgapi.ReceiveMessage(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)), objCmd.GetFieldsValue(arrKeys(3)), objCmd.GetFieldsValue(arrKeys(4)), objCmd.GetFieldsValue(arrKeys(5)), strIn, objCmd.GetFieldsValue(arrKeys(6)), objCmd.GetFieldsValue(arrKeys(7)))
				End If

				Dim iR
				For iR = 0 To arrReceiveMessage.Count - 1
					WScript.Echo arrReceiveMessage(iR)
				Next
			Case "-C"
				If colArgs.Count - 1 = 2 Then
					strId = msgapi.LookupCredits(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)))
				Else
					strId = msgapi.LookupCredits(objCmd.GetFieldsValue(arrKeys(0)), objCmd.GetFieldsValue(arrKeys(1)), objCmd.GetFieldsValue(arrKeys(2)))
				End If

				WScript.Echo strId
		End Select

		Set msgapi = Nothing
	Else
		WScript.Echo "ERROR: option not valid"
		WScript.Echo " "
		WScript.Echo objComds.GetHelpText()
	End If
Else
	WScript.Echo objComds.GetHelpText()
End If

Function GetStdIn()
	Dim strInput
	strInput = ""
	Do While Not WScript.StdIn.AtEndOfLine
		strInput = strInput & WScript.StdIn.Read(1)
	Loop
	GetStdIn = strInput
End Function


Class Commands
	Private colCommands

	Private Sub Class_Initialize()
		Set colCommands = CreateCommands()
	End Sub

	Private Sub Class_Terminate()
		Set colCommands = Nothing
	End Sub

	Public Function GetCommand(arrArgs)
		Dim objCommand
		Set objCommand = Nothing

		If InStr(1, arrArgs(0), "-") = 1 Then
			'resolve key of command
			Dim start
			Dim strKey
			start = 1
			strKey = arrArgs(0)
			If arrArgs.Count > 1 Then
				If InStr(1, arrArgs(1), "-") = 1 Then
					strKey = strKey + " " + arrArgs(1)
					start = start + 1
				End If
			End If

			'looking for the command
			Set objCommand = GetDictionaryItem(colCommands, strKey)
			If Not (objCommand Is Nothing) Then
				'could be more fields then arguments, because of optional fields
				If objCommand.GetCountRequiredFields() > (arrArgs.Count - start) Then
					Set objCommand = Nothing
					WScript.Echo "ERROR: wrong count of arguments"
					WScript.Echo " "
				Else
					'set field values of the command
					Dim fieldsKeys
					fieldsKeys = objCommand.Fields.Keys

					Dim i
					For i = start To arrArgs.Count - 1
						'set field values
						objCommand.AddFieldValue fieldsKeys(i - start), arrArgs(i)
					Next
				End If
			End If
		End If

		Set GetCommand = objCommand
	End Function

	Private Function GetDictionaryItem(colSource, strkey)
		Dim objItem
		Set objItem = Nothing

		If colSource.Exists(strkey) Then
			Dim arrKeys
			Dim arrItems
			arrKeys = colSource.Keys
			arrItems = colSource.Items

			Dim i
			For i = 0 To UBound(arrKeys)
				If arrKeys(i) = strKey Then
					Set objItem = arrItems(i)
					Exit For
				End If
			Next
		End If

		Set GetDictionaryItem = objItem
	End Function

	Public Function GetHelpText()
		Dim strHelpText
		For Each objCmd In colCommands.Items()
			strHelpText = strHelpText + objCmd.OptionArg

			Dim arrFieldsKey
			Dim arrFieldsItem
			arrFieldsKey = objCmd.Fields.Keys
			arrFieldsItem = objCmd.Fields.Items

			Dim i
			For i = 0 To UBound(arrFieldsKey)
				If (arrFieldsItem(i)) Then
					strHelpText = strHelpText + " <" + arrFieldsKey(i) + ">"
				Else
					strHelpText = strHelpText + " [" + arrFieldsKey(i) + "]"
				End If
			Next

			strHelpText = strHelpText + vbCrLf + vbCrLf + objCmd.Description + vbCrLf + vbCrLf
		Next

		GetHelpText = strHelpText
	End Function

	Private Function CreateCommands()
		Dim colCmds
		Set colCmds = CreateObject("Scripting.Dictionary")

		'Local operations
		colCmds.Add "-e", CreateCommand("-e", + _
			"Encrypt", + _
			"Encrypt standard input using the given sender private key and recipient public key. Prints two lines to standard output: first the nonce (hex), and then the box (hex).", + _
			Array("privateKey", "publicKey"), + _
			Array())
		colCmds.Add "-d", CreateCommand("-d", + _
			"Decrypt", + _
			"Decrypt standard input using the given recipient private key and sender public key. The nonce must be given on the command line, and the box (hex) on standard input. Prints the decrypted message to standard output.", + _
			Array("privateKey", "publicKey", "nonce"), + _
			Array())
		colCmds.Add "-h -e", CreateCommand("-h -e", + _
			"Hash Email Address", + _
			"Hash an email address for identity lookup. Prints the hash in hex.", + _
			Array("email"), + _
			Array())
		colCmds.Add "-h -p", CreateCommand("-h -p", + _
			"Hash Phone Number", + _
			"Hash a phone number for identity lookup. Prints the hash in hex.", + _
			Array("phoneNo"), + _
			Array())
		colCmds.Add "-g", CreateCommand("-g", + _
			"Generate Key Pair", + _
			"Generate a new key pair and write the private and public keys to the respective files (in hex).", + _
			Array("privateKeyFile", "publicKeyFile"), + _
			Array())
		colCmds.Add "-p", CreateCommand("-p", + _
			"Derive Public Key", + _
			"Derive the public key that corresponds with the given private key.", + _
			Array("privateKeyFile"), + _
			Array())

		'Network operations
		colCmds.Add "-s", CreateCommand("-s", + _
			"Send Simple Message", + _
			"Send a message from standard input with server-side encryption to the given ID. 'from' is the API identity and 'secret' is the API secret. Returns the message ID on success.", + _
			Array("to", "from", "secret"), + _
			Array("apiUrl"))
		colCmds.Add "-S", CreateCommand("-S", + _
			"Send End-to-End Encrypted Text Message", + _
			"Encrypt standard input and send the message to the given ID. 'from' is the API identity and 'secret' is the API secret. Prints the message ID on success.", + _
			Array("to", "from", "secret", "privateKey"), + _
			Array("apiUrl"))
		colCmds.Add "-S -i", CreateCommand("-S -i", + _
			"Send End-to-End Encrypted Image Message", + _
			"Encrypt standard input and send the message to the given ID. 'from' is the API identity and 'secret' is the API secret. Prints the message ID on success.", + _
			Array("to", "from", "secret", "privateKey", "imageFilePath"), + _
			Array("apiUrl"))
		colCmds.Add "-S -f", CreateCommand("-S -f", + _
			"Send End-to-End Encrypted File Message", + _
			"Encrypt the file (and thumbnail) and send a file message to the given ID. 'from' is the API identity and 'secret' is the API secret. Prints the message ID on success.", + _
			Array("to", "from", "secret", "privateKey", "file"), + _
			Array("thumbnail", "apiUrl"))
		colCmds.Add "-l -e", CreateCommand("-l -e", + _
			"ID Lookup By Email Address", + _
			"Lookup the ID linked to the given email address (will be hashed locally).", + _
			Array("email", "from", "secret"), + _
			Array("apiUrl"))
		colCmds.Add "-l -p", CreateCommand("-l -p", + _
			"ID Lookup By Phone Number", + _
			"Lookup the ID linked to the given phone number (will be hashed locally).", + _
			Array("phoneNo", "from", "secret"), + _
			Array("apiUrl"))
		colCmds.Add "-l -k", CreateCommand("-l -k", + _
			"Fetch Public Key", + _
			"Lookup the public key for the given ID.", + _
			Array("phoneNo", "from", "secret"), + _
			Array("apiUrl"))
		colCmds.Add "-c", CreateCommand("-c", + _
			"Fetch Capability", + _
			"Fetch the capability of a Threema ID", + _
			Array("id", "from", "secret"), + _
			Array("apiUrl"))
		colCmds.Add "-D", CreateCommand("-D", + _
			"Decrypt and download", + _
			"Decrypt a box (box from the stdin) message and download (if the message is a image or file message) the file(s) to the defined directory", + _
			Array("id", "from", "secret", "privateKey", "messageId", "nonce"), + _
			Array("outputFolder", "apiUrl"))
		colCmds.Add "-C", CreateCommand("-C", + _
			"Credits", + _
			"Fetch the remaining credits", + _
			Array("from", "secret"), + _
			Array())

		Set CreateCommands = colCmds
	End Function

	Private Function CreateCommand(strOptionArg, strSubject, strDescription, arrFieldsRequired, arrFieldsOptional)
		Dim objCmd
		Set objCmd = New Command
		objCmd.OptionArg = strOptionArg
		objCmd.Subject = strSubject
		objCmd.Description = strDescription

		Dim i
		For i = 0 To UBound(arrFieldsRequired)
			objCmd.AddField arrFieldsRequired(i), True
		Next
		For i = 0 To UBound(arrFieldsOptional)
			objCmd.AddField arrFieldsOptional(i), False
		Next

		Set CreateCommand = objCmd
	End Function
End Class

Class Command
	Private colFields
	Private colFieldsValue
	Private strOptionArg
	Private strSubject
	Private strDescription

	Private Sub Class_Initialize()
		Set colFields = CreateObject("Scripting.Dictionary")
		Set colFieldsValue = CreateObject("Scripting.Dictionary")
	End Sub

	Private Sub Class_Terminate()
		Set colFields = Nothing
	End Sub

	Public Property Let OptionArg(value)
		strOptionArg = value
	End Property

	Public Property Get OptionArg
		OptionArg = strOptionArg
	End Property

	Public Property Let Subject(value)
		strSubject = value
	End Property

	Public Property Get Subject()
		Subject = strSubject
	End Property

	Public Property Let Description(value)
		strDescription = value
	End Property

	Public Property Get Description()
		Description = strDescription
	End Property

	Public Property Get Fields
		Set Fields = colFields
	End Property

	Public Function GetFieldsValue(strKey)
		GetFieldsValue = GetDictionaryItem(colFieldsValue, strKey)
	End Function

	Public Function GetCountRequiredFields()
		Dim nCount
		nCount = 0

		Dim arrItems
		arrItems = colFields.Items

		Dim i
		For i = 0 To UBound(arrItems)
			If arrItems(i) <> 0 Then
				nCount = nCount + 1
			End If
		Next

		GetCountRequiredFields = nCount
	End Function

	Function AddField(strKey, bIsRequired)
		colFields.Add strKey, bIsRequired
	End Function

	Function AddFieldValue(strKey, strValue)
		If colFieldsValue.Exists(strKey) Then
			colFieldsValue.Remove strKey
		End If
		colFieldsValue.Add strKey, strValue
	End Function

	Private Function GetDictionaryItem(colSource, strKey)
		Dim objItem
		objItem = ""

		If colSource.Exists(strKey) Then
			Dim arrKeys
			Dim arrItems
			arrKeys = colSource.Keys
			arrItems = colSource.Items

			Dim i
			For i = 0 To UBound(arrKeys)
				If arrKeys(i) = strKey Then
					objItem = arrItems(i)
					Exit For
				End If
			Next
		End If

		GetDictionaryItem = objItem
	End Function
End Class
