# msgapi-sdk-net
Version: 1.0.6

## Installation
- Install Microsoft .Net Framework 4.6 or later

## Troubleshooting
Failure 'Unable to load libsodium-64.dll...' when sending a message. This could happen if MSVCR100.DLL is missing on the system. 

To solve this problem, please install:
- Microsoft Visual C++ 2010 SP1 Redistributable Package (x86) http://www.microsoft.com/en-us/download/details.aspx?id=8328
- Microsoft Visual C++ 2010 SP1 Redistributable Package (x64) http://www.microsoft.com/en-us/download/details.aspx?id=13523


Text message sent with wrong characters. This could happen if output of Windows Console not UTF8 encoded.

Configure encoding (UTF8) for Windows Console.

PowerShell (powershell):
PS C:\>$OutputEncoding = [console]::InputEncoding = [console]::OutputEncoding = New-Object System.Text.UTF8Encoding

Command Promt (cmd):
C:\>chcp 65001

### Register msgapi as COM Component
- Using "regasm.exe" find in directory depends on oprating System 32 bit (..\Windows\Microsoft.NET\Framework\v4.0.30319) or 64 bit (..\Windows\Microsoft.NET\Framework64\v4.0.30319)

.\regasm.exe Threema.MsgApi.dll /codebase

### Add msgapi to Assambly Cache
- Manage your assembly cache with "gacutil.exe"

#### Is Threema.MsgApi already installed
.\gacutil.exe /l Threema.MsgApi

#### Install assembly
.\gacutil.exe /i C:\..\Threema.MsgApi.dll

## SDK usage

### Generate Key Pair

#### Console
.\Threema.MsgApi.Console\bin\Debug\Threema.MsgApi.Console.exe -g .\privatekey.txt .\publickey.txt

#### VB-Script
CScript.exe .\MsgApiSdk.vbs -g .\privatekey.txt .\publickey.txt

### Send End-to-End Encrypted Text Message

#### Console
echo "Test Threema Message" | .\Threema.MsgApi.Console\bin\Debug\Threema.MsgApi.Console.exe -S <id> <from> <secret> .\privatekey.txt

#### VB-Script
echo "Test Threema Message" | CScript.exe .\MsgApiSdk.vbs -S <id> <from> <secret> .\privatekey.txt


#### Public Key Store config
There is en SQLite solution implemented and could be enabled in app.config
