﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Threema.MsgApi.Console.Commands.Fields;
using Threema.MsgApi.Results;

namespace Threema.MsgApi.Console.Commands
{
	class CapabilityCommand : Command
	{
		private readonly ThreemaIDField threemaIdField;
		private readonly ThreemaIDField fromField;
		private readonly TextField secretField;

		public CapabilityCommand() :
			base("Fetch Capability", "Fetch the capability of a Threema ID")
		{
			this.threemaIdField = this.CreateThreemaId("id");
			this.fromField = this.CreateThreemaId("from");
			this.secretField = this.CreateTextField("secret");
		}

		protected override void Execute()
		{
			string threemaId = this.threemaIdField.Value;
			string from = this.fromField.Value;
			string secret = this.secretField.Value;

			CapabilityResult capabilities = this.CreateConnector(from, secret)
					.LookupKeyCapability(threemaId);

			System.Console.WriteLine(capabilities);
		}
	}
}
